
/*
 * Copyright 2011-2022 Cuberite Contributors
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

// NetworkLookup.cpp

// Implements the cNetworkLookup class representing an executor for asynchronous lookup tasks


#include "Globals.h"
#include "NetworkLookup.h"




cNetworkLookup::cNetworkLookup() :
	cIsThread("Network Lookup Executor")
{
}





cNetworkLookup::~cNetworkLookup()
{
	Stop();
}





void cNetworkLookup::ScheduleLookup(std::function<void()> a_Lookup)
{
	m_WorkQueue.EnqueueItem(std::move(a_Lookup));
}





void cNetworkLookup::Stop()
{
	m_ShouldTerminate = true;
	m_WorkQueue.Clear();
	m_WorkQueue.EnqueueItem([](){});  // Dummy work to wake up the thread
	cIsThread::Stop();
}





void cNetworkLookup::Execute()
{
	while (!m_ShouldTerminate)
	{
		// Execute the next task in the queue
		auto Work = m_WorkQueue.DequeueItem();
		Work();
	}
}



